# Utility procedures to support dragging of items.

proc itemStartDrag {c x y} {
  global lastX lastY firstX firstY
  set lastX [$c canvasx $x]
  set lastY [$c canvasy $y]
  set firstX $lastX
  set firstY $lastY
}

proc itemDrag {c x y {iList current}} {
  global lastX lastY
  set x [$c canvasx $x]
  set y [$c canvasy $y]
  foreach i $iList {
    $c move $i [expr $x-$lastX] [expr $y-$lastY]
  }
  set lastX $x
  set lastY $y
}

proc itemStopDrag {c x y fromStack {iList current}} {
  global lastX lastY firstX firstY STACKS
  set x [$c canvasx $x]
  set y [$c canvasy $y]

  # calc the target stack
  set toStack [nearestStack $x $y]

  # Special action with the left mouse key?
  if {$fromStack==$toStack} {
    if {[specialAction $fromStack [llength $iList] LEFT]} {return}
  } elseif {$toStack!=-1} {
    # move?
    if {[move $fromStack $toStack [llength $iList]]} {return}
  }

  # backdrop, if no other stack is hit
  stackRefresh $fromStack
  if {$fromStack!=$toStack && $toStack!=-1} {stackRefresh $toStack}
}
