set GAME(short) child1
set GAME(name) "Kinderspiel 1"
set GAME(rules) "You always win!"
set GAME(comment) "Kinderspiel Nummer 1"

array set DATA {
   STACKS	14

   0,x 500	 0,y 100	 0,xo	0	 0,yo	0
   1,x 500	 1,y 200	 1,xo	0	 1,yo	0
   2,x 500	 2,y 300	 2,xo	0	 2,yo	0
   3,x 500	 3,y 400	 3,xo	0	 3,yo	0

   4,x 420	 4,y 100 	 4,xo	-20	 4,yo	0
   5,x 420	 5,y 200 	 5,xo	-20	 5,yo	0
   6,x 420	 6,y 300 	 6,xo	-20	 6,yo	0
   7,x 420	 7,y 400 	 7,xo	-20	 7,yo	0

   8,x 580	 8,y 100 	 8,xo	20	 8,yo	0
   9,x 580	 9,y 200	 9,xo	20	 9,yo	0
  10,x 580	10,y 300	10,xo	20	10,yo	0
  11,x 580	11,y 400	11,xo	20	11,yo	0

  12,x 450	12,y 550	12,xo	0	12,yo	0
  13,x 550	13,y 550	13,xo	0	13,yo	0
}

proc isOk {fromStack toStack {count 1}} {
  # determine whether a movement is ok
  global OPTIONS

  # only one open card may be moved from 12 or 13
  if {$count!=1} {return 0}
  if {$fromStack!=12} {return 0}

  # check for a normal move
  set fCard [lindex [stackGet $fromStack] 0]
  if {[cardFlipped $fCard]} {return 0}
  set tCard [lindex [stackGet $toStack] 0]
  set fColor [cardPicture $fCard]
  set tColor [cardPicture $tCard]
  set fValue [cardValue $fCard]
  set tValue [cardValue $tCard]

  if {0<=$toStack && $toStack<=3} {
    if {$OPTIONS(child1,middle)>=0} {
      return [expr [stackIsEmpty $toStack] && $fValue==$OPTIONS(child1,middle)]
    } else {
      return [expr [stackIsEmpty $toStack] && \
        $fColor!=[cardPicture [stackGet 0]] && \
        $fColor!=[cardPicture [stackGet 1]] && \
        $fColor!=[cardPicture [stackGet 2]] && \
        $fColor!=[cardPicture [stackGet 3]]]
    }
  } elseif {4<=$toStack && $toStack<=7} {
    if {$OPTIONS(child1,middle)>=0} {
      if {[stackIsEmpty $toStack]} {
        return [expr $fValue==$OPTIONS(child1,middle)-1 && \
          ![stackIsEmpty [expr $toStack-4]] && \
          $fColor==[cardPicture [stackGet [expr $toStack-4]]]]
      } else {
        return [expr $fValue==($tValue-1) && $fColor==$tColor]
      }
    } else {
      if {[stackIsEmpty $toStack]} {
        return [expr ![stackIsEmpty [expr $toStack-4]] && \
          $fValue==[expr [cardValue [stackGet [expr $toStack-4]]]-1] && \
          $fColor==[cardPicture [stackGet [expr $toStack-4]]]]
      } else {
        return [expr $fValue==($tValue-1) && $fColor==$tColor]
      }
    }
  } elseif {8<=$toStack && $toStack<=11} {
    if {$OPTIONS(child1,middle)>=0} {
      if {[stackIsEmpty $toStack]} {
        return [expr $fValue==$OPTIONS(child1,middle)+1 && \
          ![stackIsEmpty [expr $toStack-8]] && \
          $fColor==[cardPicture [stackGet [expr $toStack-8]]]]
      } else {
        return [expr $fValue==($tValue+1) && $fColor==$tColor]
      }
    } else {
      if {[stackIsEmpty $toStack]} {
        return [expr ![stackIsEmpty [expr $toStack-8]] && \
          $fValue==[expr [cardValue [stackGet [expr $toStack-8]]]+1] && \
          $fColor==[cardPicture [stackGet [expr $toStack-8]]]]
      } else {
        return [expr $fValue==($tValue+1) && $fColor==$tColor]
      }
    }
  } else {
    return 0
  }
  return 1
}

# THE FOLLOWING MUST BE IMPLEMENTED!!!

proc move {fromStack toStack {count 1}} {
  if {[isOk $fromStack $toStack $count]} {
    set redo "stackMove $fromStack $toStack $count"
    set undo "stackMove $toStack $fromStack $count"
    moveAdd $redo $undo
    return 1
  } else {
    return 0
  }
}

proc specialAction {stack {count 1} {type RIGHT}} {
  if {![stackIsEmpty $stack]} {
    if {$stack==13} {
      set redo "stackMoveFlipped 13 12 1"
      set undo "stackMoveFlipped 12 13 1"
      moveAdd $redo $undo
      return 1
    } elseif {$stack==12 && [stackIsEmpty 13]} {
      set redo "stackMoveFlipped 12 13 all"
      set undo "stackMoveFlipped 13 12 all"
      moveAdd $redo $undo
      return 1
    }
  }
  return 0
}

proc autoPlay {} {}

proc finish {} {
  # return 1 for winner, -1 for loser, and 0 for game on
  return [expr [stackIsEmpty 12] && [stackIsEmpty 13]]
}

proc initGame {{startSeed ""}} {
  global CARDS OPTIONS

  set GAME(start) [clock seconds]

  # OPTIONS
  # -------
  # autoplay		enable this feature (n/a here)
  # child1,middle	<value>, -1 (no matter)

  set OPTIONS(autoplay) 0
  set OPTIONS(child1,middle) -1

  set CARDS {}
  for {set i 0} {$i<52} {incr i} {lappend CARDS [expr -$i-1]}

  wm geometry . 975x650+15+25

  set GAME(seed) $startSeed
  if {$GAME(seed)==""} {
    set GAME(seed) [expr [clock seconds]%65536]
  }

  mix $GAME(seed)

  stackRemoveCards all all 0
  stackAddCards 13 $CARDS 0

  stackRefresh
  moveInit
}
