proc sqr {x} {return [expr $x*$x]}

proc distPP {x1 y1 x2 y2} {
  # return the distance between two points
  return [expr sqrt([sqr [expr $x2-$x1]]+[sqr [expr $y2-$y1]])]
}

proc distPL {x1 y1 px1 py1 px2 py2} {
  # return the approx min distance of a point to a line
  set d1 [distPP $x1 $y1 $px1 $py1]
  set d2 [distPP $x1 $y1 $px2 $py2]
  set d3 [distPP $x1 $y1 [expr 0.5*($px1+$px2)] [expr 0.5*($py1+$py2)]]
  return [min $d1 $d2 $d3]
}

proc distPR {x1 y1 px1 py1 px2 py2} {
  # return the min distance between a point and a rectangle
  set d1 [distPL $x1 $y1 $px1 $py1 $px1 $py2]
  set d2 [distPL $x1 $y1 $px1 $py1 $px2 $py1]
  set d3 [distPL $x1 $y1 $px2 $py2 $px1 $py2]
  set d4 [distPL $x1 $y1 $px2 $py2 $px2 $py1]
  return [min $d1 $d2 $d3 $d4]
}
