proc block {{window .}} {
  # block a window
  catch {grab ungrab .block}
  catch {destroy .block}
  toplevel .block
  grab .block
  wm withdraw .block
  #$window configure -cursor wait
}

proc unblock {{window .}} {
  # unblock a window
  catch {grab ungrab .block}
  catch {destroy .block}
  #$window configure -cursor {}
}

proc message {msg {title "Message"}} {
  tk_messageBox -message $msg -type ok -title $title -icon info
}

proc min {args} {
  set t [lindex $args 0]
  foreach a $args {
    if {$a<$t} {set t $a}
  }
  return $t
}

proc max {args} {
  set t [lindex $args 0]
  foreach a $args {
    if {$a>$t} {set t $a}
  }
  return $t
}

proc mixMode {str} {
  # transfer a string to mix mode
  set str [string tolower $str]
  foreach c {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
    regsub -all -- "^$c" $str [string toupper $c] str
    regsub -all -- "(\[^a-zA-Z\])$c" $str "\\1[string toupper $c]" str
  } 
  return $str
}

proc nodup { list } {
  # Doppelte Eintraege aus einer unsortierten Liste entfernen. Die Liste ist
  # danach sortiert!

  # Berechne einmalig die Listenlaenge
  set len [llength $list]
  # Sonderfall: Liste ist leer
  if { $len > 0 } {
    # Besetze tempoaere Liste mit der sortierten Ausgangsliste
    set ltmp [lsort -ascii $list]
    # Aktuelles Vergleichselement $vgl
    set vgl [lindex $ltmp 0]
    # Vorbesetzen des Ergebnisses
    set l [list [lindex $ltmp 0]]
    # Schleife ueber die sortierte Liste zum Aufsammeln
    set i 1
    while { $i < $len } {
      set cur [lindex $ltmp $i]
      # Wert nur aufnehmen, wenn er nicht schon da ist
      if { [string compare $cur $vgl] != 0 } {
        lappend l $cur
        set vgl $cur
      }
      incr i
    }
  } else {
    # Leere Liste --> Leeres Ergebnis
    set l {}
  }
  # Gib das Ergebnis zurueck
  return $l
}

proc revList {l} {
  # return the reverted list
  set ret {}
  for {set i [expr [llength $l]-1]} {$i>=0} {incr i -1} {
    lappend ret [lindex $l $i]
  }
  return $ret
}

proc enuDate {d} {
	return [clock format $d -format "%Y/%m/%d %H:%M"]
}

proc listFormat {fmt l} {
	eval format {$fmt} $l
}
